diff --git a/gnu/packages/mail.scm b/gnu/packages/mail.scm
index 9f88bbf70d..8e56efaddd 100644
--- a/gnu/packages/mail.scm
+++ b/gnu/packages/mail.scm
@@ -1184,47 +1184,49 @@ (define-public bogofilter
     (license license:gpl3+)))
 
 (define-public offlineimap3
-  (package
-    (name "offlineimap3")
-    (version "8.0.0")
-    (source (origin
-              (method git-fetch)
-              (uri (git-reference
-                    (url "https://github.com/OfflineIMAP/offlineimap3")
-                    (commit (string-append "v" version))))
-              (file-name (git-file-name name version))
-              (sha256
-               (base32
-                "0y3giaz9i8vvczlxkbwymfkn3vi9fv599dy4pc2pn2afxsl4mg2w"))))
-    (build-system python-build-system)
-    (native-inputs
-     (list asciidoc))
-    (inputs
-     (list python-distro python-imaplib2 python-rfc6555))
-    (arguments
-     `(;; Tests require a modifiable IMAP account.
-       #:tests? #f
-       #:phases
-       (modify-phases %standard-phases
-         (add-after 'build 'build-documentation
-           (lambda _
-             (substitute* "docs/Makefile"
-               ;; Prevent xmllint and xsltproc from downloading a DTD file.
-               (("a2x -v") "a2x --no-xmllint --xsltproc-opts=--nonet -v"))
-             (invoke "make" "-C" "docs" "man")))
-         (add-after 'install 'install-documentation
-           (lambda* (#:key outputs #:allow-other-keys)
-             (let* ((out (assoc-ref outputs "out"))
-                    (man (string-append out "/share/man")))
-               (install-file "docs/offlineimap.1" (string-append man "/man1"))
-               (install-file "docs/offlineimapui.7" (string-append man "/man7"))))))))
-    (home-page "https://www.offlineimap.org")
-    (synopsis "Sync emails between two repositories")
-    (description
-     "OfflineImap synchronizes emails between two repositories, so that you
+  (let ((commit "db347452273bb0f1b1a8ea952f6fb46cf95fedbf")
+        (revision "0"))
+    (package
+      (name "offlineimap3")
+      (version (git-version "8.0.0" revision commit))
+      (source (origin
+                (method git-fetch)
+                (uri (git-reference
+                      (url "https://github.com/OfflineIMAP/offlineimap3")
+                      (commit commit)))
+                (file-name (git-file-name name version))
+                (sha256
+                 (base32
+                  "0af6qxnjihpk29ns5i8545yj5spa0a0w85vrikaja768xc56wkrg"))))
+      (build-system python-build-system)
+      (native-inputs
+       (list asciidoc python-wheel))
+      (inputs
+       (list python-distro python-imaplib2 python-rfc6555 python-urllib3-1.25))
+      (arguments
+       `(;; Tests require a modifiable IMAP account.
+         #:tests? #f
+                  #:phases
+                  (modify-phases %standard-phases
+                    (add-after 'build 'build-documentation
+                      (lambda _
+                        (substitute* "docs/Makefile"
+                          ;; Prevent xmllint and xsltproc from downloading a DTD file.
+                          (("a2x -v") "a2x --no-xmllint --xsltproc-opts=--nonet -v"))
+                        (invoke "make" "-C" "docs" "man")))
+                    (add-after 'install 'install-documentation
+                      (lambda* (#:key outputs #:allow-other-keys)
+                        (let* ((out (assoc-ref outputs "out"))
+                               (man (string-append out "/share/man")))
+                          (install-file "docs/offlineimap.1" (string-append man "/man1"))
+                          (install-file "docs/offlineimapui.7" (string-append man "/man7"))))))))
+      (home-page "https://www.offlineimap.org")
+      (synopsis "Sync emails between two repositories")
+      (description
+       "OfflineImap synchronizes emails between two repositories, so that you
 can read the same mailbox from multiple computers.  It supports IMAP as REMOTE
 repository and Maildir/IMAP as LOCAL repository.")
-    (license license:gpl2+)))
+      (license license:gpl2+))))
 
 (define-public offlineimap
   (deprecated-package "offlineimap" offlineimap3))