diff --git a/gnu/packages/kde-frameworks.scm b/gnu/packages/kde-frameworks.scm
index b3dec5f4aa4..069b3e14c72 100644
--- a/gnu/packages/kde-frameworks.scm
+++ b/gnu/packages/kde-frameworks.scm
@@ -5334,131 +5334,6 @@ (define-public kde-frameworkintegration
 ;; from kdelibs 4 to KDE Frameworks 5. Code should aim to port away from this
 ;; framework, new projects should avoid using these libraries.
 
-(define-public kdelibs4support
-  (package
-    (name "kdelibs4support")
-    (version "5.114.0")
-    (source
-     (origin
-       (method url-fetch)
-       (uri (string-append
-             "mirror://kde/stable/frameworks/"
-             (version-major+minor version) "/portingAids/"
-             name "-" version ".tar.xz"))
-       (sha256
-        (base32 "17473him2fjfcw5f88diarqac815wsakfyb9fka82a4qqh9l41mc"))
-       (modules '((guix build utils)))
-       (snippet
-        '(substitute* "autotests/kmimetypetest.cpp"
-           ;; Adjust the test for shared-mime-info changes:
-           ;; https://gitlab.freedesktop.org/xdg/shared-mime-info/-/issues/202
-           ;; https://gitlab.freedesktop.org/xdg/shared-mime-info/-/merge_requests/255
-           (("empty document") "Empty document")
-           (("Bzip archive") "Bzip2 archive")
-           (("<< \"application/x-bzip") "<< \"application/x-bzip2")))))
-    (build-system cmake-build-system)
-    (native-inputs
-     (list dbus
-           docbook-xml-4.4 ; optional
-           extra-cmake-modules
-           kdoctools
-           perl
-           perl-uri
-           pkg-config
-           qttools
-           shared-mime-info
-           kjobwidgets ;; required for running the tests
-           strace
-           tzdata-for-tests))
-    (propagated-inputs
-     ;; These are required to be installed along with this package, see
-     ;; lib64/cmake/KF5KDELibs4Support/KF5KDELibs4SupportConfig.cmake
-     (list karchive
-           kauth
-           kconfigwidgets
-           kcoreaddons
-           kcrash
-           kdbusaddons
-           kdesignerplugin
-           kdoctools
-           kemoticons
-           kguiaddons
-           kiconthemes
-           kinit
-           kitemmodels
-           knotifications
-           kparts
-           ktextwidgets
-           kunitconversion
-           kwindowsystem
-           qtbase-5))
-    (inputs
-     (list kcompletion
-           kconfig
-           kded
-           kglobalaccel
-           ki18n
-           kio
-           kservice
-           kwidgetsaddons
-           kxmlgui
-           libsm
-           networkmanager-qt
-           openssl
-           qtsvg-5
-           qttools-5
-           qtx11extras))
-    ;; FIXME: Use Guix ca-bundle.crt in etc/xdg/ksslcalist and
-    ;; share/kf5/kssl/ca-bundle.crt
-    ;; TODO: NixOS has nix-kde-include-dir.patch to change std-dir "include"
-    ;; into "@dev@/include/". Think about whether this is needed for us, too.
-    (arguments
-     `(#:phases
-       (modify-phases %standard-phases
-         (add-after 'unpack 'make-cmake-to-find-docbook
-           (lambda _
-             (substitute* "cmake/FindDocBookXML4.cmake"
-               (("^.*xml/docbook/schema/dtd.*$")
-                "xml/dtd/docbook\n"))))
-         (delete 'check)
-         (add-after 'install 'check-post-install
-           (lambda* (#:key inputs tests? #:allow-other-keys)
-             (setenv "HOME" (getcwd))
-             (setenv "TZDIR"    ; KDateTimeTestsome needs TZDIR
-                     (search-input-directory inputs
-                                             "share/zoneinfo"))
-             ;; Make Qt render "offscreen", required for tests
-             (setenv "QT_QPA_PLATFORM" "offscreen")
-             ;; enable debug output
-             (setenv "CTEST_OUTPUT_ON_FAILURE" "1") ; enable debug output
-             (setenv "DBUS_FATAL_WARNINGS" "0")
-             ;; Make kstandarddirstest pass (see https://bugs.kde.org/381098)
-             (mkdir-p ".kde-unit-test/xdg/config")
-             (with-output-to-file ".kde-unit-test/xdg/config/foorc"
-               (lambda () #t))  ;; simply touch the file
-             ;; Blacklist a test-function (failing at build.kde.org, too).
-             (with-output-to-file "autotests/BLACKLIST"
-               (lambda _
-                 (display "[testSmb]\n*\n")))
-             (invoke "dbus-launch" "ctest"
-                     "-E" "kstandarddirstest"))))))
-    (home-page "https://community.kde.org/Frameworks")
-    (synopsis "KDE Frameworks 5 porting aid from KDELibs4")
-    (description "This framework provides code and utilities to ease the
-transition from kdelibs 4 to KDE Frameworks 5.  This includes CMake macros and
-C++ classes whose functionality has been replaced by code in CMake, Qt and
-other frameworks.
-
-Code should aim to port away from this framework eventually.  The API
-documentation of the classes in this framework and the notes at
-http://community.kde.org/Frameworks/Porting_Notes should help with this.")
-    ;; Most files are distributed under LGPL2+, but the package includes code
-    ;; under a variety of licenses.
-    (license (list license:lgpl2.1+ license:lgpl2.0 license:lgpl2.0+
-                   license:gpl2 license:gpl2+
-                   license:expat license:bsd-2 license:bsd-3
-                   license:public-domain))))
-
 (define-public khtml
   (package
     (name "khtml")